Index: trunk/source/geometry/solids/specific/include/G4TwistTubsHypeSide.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistTubsHypeSide.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistTubsHypeSide.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTubsHypeSide.hh,v 1.5 2006/06/29 18:47:56 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4TwistTubsSide.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistTubsSide.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistTubsSide.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTubsSide.hh,v 1.5 2006/06/29 18:47:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4TwistedBox.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistedBox.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistedBox.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedBox.hh,v 1.10 2006/06/29 18:48:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4TwistedTrap.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistedTrap.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistedTrap.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTrap.hh,v 1.10 2006/06/29 18:48:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4TwistedTrd.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistedTrd.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistedTrd.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTrd.hh,v 1.6 2006/06/29 18:48:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4TwistedTubs.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4TwistedTubs.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4TwistedTubs.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTubs.hh,v 1.14 2007/05/23 09:32:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4VCSGface.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VCSGface.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VCSGface.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VCSGface.hh,v 1.9 2008/05/15 11:41:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4VCSGfaceted.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VCSGfaceted.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VCSGfaceted.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VCSGfaceted.hh,v 1.17 2008/05/15 13:45:15 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4VFacet.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VFacet.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VFacet.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VFacet.hh,v 1.7 2008/12/18 12:57:30 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/include/G4VFacet.icc
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VFacet.icc	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VFacet.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VFacet.icc,v 1.6 2008/12/18 12:57:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/include/G4VTwistSurface.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VTwistSurface.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VTwistSurface.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTwistSurface.hh,v 1.6 2007/05/11 13:54:28 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4VTwistSurface.icc
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VTwistSurface.icc	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VTwistSurface.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTwistSurface.icc,v 1.3 2006/06/29 18:48:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/include/G4VTwistedFaceted.hh
===================================================================
--- trunk/source/geometry/solids/specific/include/G4VTwistedFaceted.hh	(revision 1227)
+++ trunk/source/geometry/solids/specific/include/G4VTwistedFaceted.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTwistedFaceted.hh,v 1.10 2006/10/20 13:45:20 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/specific/src/G4ClippablePolygon.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4ClippablePolygon.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4ClippablePolygon.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ClippablePolygon.cc,v 1.12 2007/05/11 13:54:28 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4Ellipsoid.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Ellipsoid.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Ellipsoid.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4Ellipsoid.cc,v 1.14 2007/05/18 07:39:56 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Ellipsoid.cc,v 1.24 2009/09/24 15:51:02 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Ellipsoid
@@ -385,21 +385,20 @@
   EInside in;
 
+  static const G4double halfRadTolerance=kRadTolerance*0.5;
+
   // check this side of z cut first, because that's fast
   //
-  if (p.z() < zBottomCut-kRadTolerance/2.0)
-    { return in=kOutside; }
-  if (p.z() > zTopCut+kRadTolerance/2.0)
-    { return in=kOutside; }
-
-  rad2oo= sqr(p.x()/(xSemiAxis+kRadTolerance/2.))
-        + sqr(p.y()/(ySemiAxis+kRadTolerance/2.))
-        + sqr(p.z()/(zSemiAxis+kRadTolerance/2.));
-
-  if (rad2oo > 1.0)
-    { return in=kOutside; }
+  if (p.z() < zBottomCut-halfRadTolerance) { return in=kOutside; }
+  if (p.z() > zTopCut+halfRadTolerance)    { return in=kOutside; }
+
+  rad2oo= sqr(p.x()/(xSemiAxis+halfRadTolerance))
+        + sqr(p.y()/(ySemiAxis+halfRadTolerance))
+        + sqr(p.z()/(zSemiAxis+halfRadTolerance));
+
+  if (rad2oo > 1.0)  { return in=kOutside; }
     
-  rad2oi= sqr(p.x()*(1.0+kRadTolerance/2./xSemiAxis)/xSemiAxis)
-      + sqr(p.y()*(1.0+kRadTolerance/2./ySemiAxis)/ySemiAxis)
-      + sqr(p.z()*(1.0+kRadTolerance/2./zSemiAxis)/zSemiAxis);
+  rad2oi= sqr(p.x()*(1.0+halfRadTolerance/xSemiAxis)/xSemiAxis)
+      + sqr(p.y()*(1.0+halfRadTolerance/ySemiAxis)/ySemiAxis)
+      + sqr(p.z()*(1.0+halfRadTolerance/zSemiAxis)/zSemiAxis);
 
   // Check radial surfaces
@@ -408,6 +407,7 @@
   if (rad2oi < 1.0)
   {
-    in = ( (p.z() < zBottomCut+kRadTolerance/2.0)
-        || (p.z() > zTopCut-kRadTolerance/2.0) ) ? kSurface : kInside;
+    in = ( (p.z() < zBottomCut+halfRadTolerance)
+        || (p.z() > zTopCut-halfRadTolerance) ) ? kSurface : kInside;
+    if ( rad2oi > 1.0-halfRadTolerance )  { in=kSurface; }
   }
   else 
@@ -415,6 +415,6 @@
     in = kSurface;
   }
-
   return in;
+
 }
 
@@ -460,28 +460,34 @@
                                     const G4ThreeVector& v  ) const
 {
-  G4double distMin;
-  
+  static const G4double halfCarTolerance=kCarTolerance*0.5;
+  static const G4double halfRadTolerance=kRadTolerance*0.5;
+
+  G4double distMin = std::min(xSemiAxis,ySemiAxis);
+  const G4double dRmax = 100.*std::min(distMin,zSemiAxis);
   distMin= kInfinity;
 
   // check to see if Z plane is relevant
-  if (p.z() < zBottomCut) {
-    if (v.z() <= 0.0)
-      return distMin;
+  if (p.z() <= zBottomCut+halfCarTolerance)
+  {
+    if (v.z() <= 0.0) { return distMin; }
     G4double distZ = (zBottomCut - p.z()) / v.z();
-    if (distZ > kRadTolerance/2.0 && Inside(p+distZ*v) != kOutside )
-      {
-        // early exit since can't intercept curved surface if we reach here
-        return distMin= distZ;
-      }
-  }
-  if (p.z() > zTopCut) {
-    if (v.z() >= 0.0)
-      return distMin;
+
+    if ( (distZ > -halfRadTolerance) && (Inside(p+distZ*v) != kOutside) )
+    {
+      // early exit since can't intercept curved surface if we reach here
+      if ( std::abs(distZ) < halfRadTolerance ) { distZ=0.; }
+      return distMin= distZ;
+    }
+  }
+  if (p.z() >= zTopCut-halfCarTolerance)
+  {
+    if (v.z() >= 0.0) { return distMin;}
     G4double distZ = (zTopCut - p.z()) / v.z();
-    if (distZ > kRadTolerance/2.0 && Inside(p+distZ*v) != kOutside )
-      {
-        // early exit since can't intercept curved surface if we reach here
-        return distMin= distZ;
-      }
+    if ( (distZ > -halfRadTolerance) && (Inside(p+distZ*v) != kOutside) )
+    {
+      // early exit since can't intercept curved surface if we reach here
+      if ( std::abs(distZ) < halfRadTolerance ) { distZ=0.; }
+      return distMin= distZ;
+    }
   }
   // if fZCut1 <= p.z() <= fZCut2, then must hit curved surface
@@ -492,31 +498,51 @@
   A= sqr(v.x()/xSemiAxis) + sqr(v.y()/ySemiAxis) + sqr(v.z()/zSemiAxis);
   C= sqr(p.x()/xSemiAxis) + sqr(p.y()/ySemiAxis) + sqr(p.z()/zSemiAxis) - 1.0;
-  B= 2.0 * ( p.x()*v.x()/(xSemiAxis*xSemiAxis) + p.y()*v.y()/(ySemiAxis*ySemiAxis)
-             + p.z()*v.z()/(zSemiAxis*zSemiAxis) );
+  B= 2.0 * ( p.x()*v.x()/(xSemiAxis*xSemiAxis)
+           + p.y()*v.y()/(ySemiAxis*ySemiAxis)
+           + p.z()*v.z()/(zSemiAxis*zSemiAxis) );
 
   C= B*B - 4.0*A*C;
   if (C > 0.0)
-    {
-      G4double distR= (-B - std::sqrt(C) ) / (2.0*A);
-      G4double intZ= p.z()+distR*v.z();
-      if (distR > kRadTolerance/2.0
-          && intZ >= zBottomCut-kRadTolerance/2.0
-          && intZ <= zTopCut+kRadTolerance/2.0)
-        {
-          distMin = distR;
-        }
-      else
-        {
-          distR= (-B + std::sqrt(C) ) / (2.0*A);
-          intZ= p.z()+distR*v.z();
-          if (distR > kRadTolerance/2.0
-              && intZ >= zBottomCut-kRadTolerance/2.0
-              && intZ <= zTopCut+kRadTolerance/2.0)
-            {
-              distMin = distR;
-            }
-        }
-    }
-
+  {    
+    G4double distR= (-B - std::sqrt(C)) / (2.0*A);
+    G4double intZ = p.z()+distR*v.z();
+    if ( (distR > halfRadTolerance)
+      && (intZ >= zBottomCut-halfRadTolerance)
+      && (intZ <= zTopCut+halfRadTolerance) )
+    { 
+      distMin = distR;
+    }
+    else if( (distR >- halfRadTolerance)
+	    && (intZ >= zBottomCut-halfRadTolerance)
+	    && (intZ <= zTopCut+halfRadTolerance) )
+    {
+      // p is on the curved surface, DistanceToIn returns 0 or kInfinity:
+      // DistanceToIn returns 0, if second root is positive (means going inside)
+      // If second root is negative, DistanceToIn returns kInfinity (outside)
+      //
+      distR = (-B + std::sqrt(C) ) / (2.0*A);
+      if(distR>0.) { distMin=0.; }
+    }
+    else
+    {
+      distR= (-B + std::sqrt(C)) / (2.0*A);
+      intZ = p.z()+distR*v.z();
+      if ( (distR > halfRadTolerance)
+        && (intZ >= zBottomCut-halfRadTolerance)
+        && (intZ <= zTopCut+halfRadTolerance) )
+      {
+        G4ThreeVector norm=SurfaceNormal(p);
+        if (norm.dot(v)<0.) { distMin = distR; }
+      }
+    }
+    if ( (distMin!=kInfinity) && (distMin>dRmax) ) 
+    {                    // Avoid rounding errors due to precision issues on
+                         // 64 bits systems. Split long distances and recompute
+      G4double fTerm = distMin-std::fmod(distMin,dRmax);
+      distMin = fTerm + DistanceToIn(p+fTerm*v,v);
+    }
+  }
+  
+  if (std::abs(distMin)<halfRadTolerance) { distMin=0.; }
   return distMin;
 } 
@@ -651,5 +677,5 @@
       {
         case kPlaneSurf:
-          *n= G4ThreeVector(0.,0.,(v.z() > 1.0 ? 1. : -1.));
+          *n= G4ThreeVector(0.,0.,(v.z() > 0.0 ? 1. : -1.));
           break;
         case kCurvedSurf:
@@ -683,4 +709,5 @@
     }
   }
+   
   return distMin;
 }
@@ -905,9 +932,9 @@
   max1  = xSemiAxis > ySemiAxis ? xSemiAxis : ySemiAxis;
   max1  = max1 > zSemiAxis ? max1 : zSemiAxis;
-  if(max1 == xSemiAxis){max2 = ySemiAxis; max3 = zSemiAxis;}
-  else if(max1 == ySemiAxis){max2 = xSemiAxis; max3 = zSemiAxis;}
-  else {max2 = xSemiAxis; max3 = ySemiAxis; }
-
-  phi   = RandFlat::shoot(0.,2.*pi);
+  if (max1 == xSemiAxis)      { max2 = ySemiAxis; max3 = zSemiAxis; }
+  else if (max1 == ySemiAxis) { max2 = xSemiAxis; max3 = zSemiAxis; }
+  else                        { max2 = xSemiAxis; max3 = ySemiAxis; }
+
+  phi   = RandFlat::shoot(0.,twopi);
   theta = RandFlat::shoot(0.,pi);
   
Index: trunk/source/geometry/solids/specific/src/G4EllipticalCone.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4EllipticalCone.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4EllipticalCone.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4EllipticalCone.cc,v 1.16 2008/04/25 08:45:26 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Implementation of G4EllipticalCone class
Index: trunk/source/geometry/solids/specific/src/G4EllipticalTube.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4EllipticalTube.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4EllipticalTube.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EllipticalTube.cc,v 1.27 2006/10/20 13:45:21 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4EnclosingCylinder.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4EnclosingCylinder.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4EnclosingCylinder.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EnclosingCylinder.cc,v 1.10 2007/05/11 13:54:29 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4ExtrudedSolid.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4ExtrudedSolid.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4ExtrudedSolid.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ExtrudedSolid.cc,v 1.18 2008/10/30 11:47:45 ivana Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/solids/specific/src/G4Hype.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Hype.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Hype.cc	(revision 1228)
@@ -27,5 +27,5 @@
 // $Id: G4Hype.cc,v 1.27 2008/04/14 08:49:28 gcosmo Exp $
 // $Original: G4Hype.cc,v 1.0 1998/06/09 16:57:50 safai Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4IntersectingCone.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4IntersectingCone.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4IntersectingCone.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4IntersectingCone.cc,v 1.12 2008/04/28 08:59:47 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4Paraboloid.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Paraboloid.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Paraboloid.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4Paraboloid.cc,v 1.8 2008/07/17 07:33:00 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Paraboloid.cc,v 1.9 2009/02/27 15:10:46 tnikitin Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Paraboloid
@@ -866,4 +866,5 @@
       *n = G4ThreeVector(p.x() + intersection * v.x(), p.y()
          + intersection * v.y(), - k1 / 2);
+      *n = n->unit();
     }
     return intersection;
Index: trunk/source/geometry/solids/specific/src/G4PolyPhiFace.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4PolyPhiFace.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4PolyPhiFace.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PolyPhiFace.cc,v 1.15 2008/05/15 11:41:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4Polycone.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Polycone.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Polycone.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Polycone.cc,v 1.43 2008/05/15 13:45:15 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4PolyconeSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4PolyconeSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4PolyconeSide.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4PolyconeSide.cc,v 1.19 2008/05/15 11:41:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4PolyconeSide.cc,v 1.22 2009/11/11 12:23:37 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -462,6 +462,5 @@
   if (p == G4ThreeVector(0.,0.,0.))  { return p; }
 
-  G4ThreeVector dFrom;
-  G4double dOut2;
+  G4double dFrom, dOut2;
   
   dFrom = DistanceAway( p, false, dOut2 );
@@ -470,5 +469,6 @@
   
   G4double rad = p.perp();
-  return G4ThreeVector( rNorm*p.x()/rad, rNorm*p.y()/rad, zNorm );
+  if (rad!=0.) { return G4ThreeVector(rNorm*p.x()/rad,rNorm*p.y()/rad,zNorm); }
+  return G4ThreeVector( 0.,0., zNorm ).unit();
 }
 
Index: trunk/source/geometry/solids/specific/src/G4Polyhedra.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Polyhedra.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Polyhedra.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Polyhedra.cc,v 1.42 2008/05/15 13:45:15 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4PolyhedraSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4PolyhedraSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4PolyhedraSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PolyhedraSide.cc,v 1.15 2008/05/15 11:41:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4QuadrangularFacet.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4QuadrangularFacet.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4QuadrangularFacet.cc	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4QuadrangularFacet.cc,v 1.7 2008/12/18 12:57:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/src/G4ReduciblePolygon.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4ReduciblePolygon.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4ReduciblePolygon.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ReduciblePolygon.cc,v 1.11 2006/06/29 18:48:53 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4SolidExtentList.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4SolidExtentList.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4SolidExtentList.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SolidExtentList.cc,v 1.5 2007/05/11 13:54:29 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TessellatedGeometryAlgorithms.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TessellatedGeometryAlgorithms.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TessellatedGeometryAlgorithms.cc	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4TessellatedGeometryAlgorithms.cc,v 1.6 2008/12/18 12:57:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/src/G4TessellatedSolid.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TessellatedSolid.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TessellatedSolid.cc	(revision 1228)
@@ -25,6 +25,6 @@
 // ********************************************************************
 //
-// $Id: G4TessellatedSolid.cc,v 1.18 2008/03/13 11:58:28 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4TessellatedSolid.cc,v 1.19 2009/04/27 08:06:27 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -520,4 +520,5 @@
     } while (nearParallel && m!=maxTries);
 
+#ifdef G4VERBOSE
     if (m == maxTries)
     {
@@ -528,8 +529,18 @@
 // something wrong with geometry.
 //
+      G4cout.precision(16) ;
+      G4cout << G4endl ;
+      G4cout << "Solid name       = " << GetName()  << G4endl;
+      G4cout << "Geometry Type    = " << geometryType  << G4endl;
+      G4cout << "Number of facets = " << facets.size() << G4endl;
+      G4cout << "Position:"  << G4endl << G4endl ;
+      G4cout << "p.x() = "   << p.x()/mm << " mm" << G4endl ;
+      G4cout << "p.y() = "   << p.y()/mm << " mm" << G4endl ;
+      G4cout << "p.z() = "   << p.z()/mm << " mm" << G4endl << G4endl ;
       G4Exception("G4TessellatedSolid::Inside()",
-                "UnknownInsideOutside", FatalException,
+                "UnknownInsideOutside-MaxTries", JustWarning,
                 "Cannot determine whether point is inside or outside volume!");
     }
+#endif
 //
 //
@@ -550,5 +561,6 @@
       locationprime = kInside;
 
-    if (i == 0) location = locationprime;
+    if (i == 0)  { location = locationprime; }
+#ifdef G4VERBOSE
     else if (locationprime != location)
     {
@@ -558,8 +570,18 @@
 // geometry is not constructed correctly.
 //
+      G4cout.precision(16) ;
+      G4cout << G4endl ;
+      G4cout << "Solid name       = " << GetName()  << G4endl;
+      G4cout << "Geometry Type    = " << geometryType  << G4endl;
+      G4cout << "Number of facets = " << facets.size() << G4endl;
+      G4cout << "Position:"  << G4endl << G4endl ;
+      G4cout << "p.x() = "   << p.x()/mm << " mm" << G4endl ;
+      G4cout << "p.y() = "   << p.y()/mm << " mm" << G4endl ;
+      G4cout << "p.z() = "   << p.z()/mm << " mm" << G4endl << G4endl ;
       G4Exception("G4TessellatedSolid::Inside()",
-                "UnknownInsideOutside", FatalException,
+                "UnknownInsideOutside", JustWarning,
                 "Cannot determine whether point is inside or outside volume!");
     }
+#endif
   }
 
Index: trunk/source/geometry/solids/specific/src/G4Tet.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4Tet.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4Tet.cc	(revision 1228)
@@ -29,5 +29,5 @@
 //
 // $Id: G4Tet.cc,v 1.11 2006/11/13 08:58:03 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Tet
Index: trunk/source/geometry/solids/specific/src/G4TriangularFacet.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TriangularFacet.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TriangularFacet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TriangularFacet.cc,v 1.12 2008/11/13 08:25:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/src/G4TwistBoxSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistBoxSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistBoxSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistBoxSide.cc,v 1.6 2007/05/23 09:31:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTrapAlphaSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTrapAlphaSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTrapAlphaSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTrapAlphaSide.cc,v 1.8 2007/05/23 13:26:06 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTrapFlatSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTrapFlatSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTrapFlatSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTrapFlatSide.cc,v 1.6 2007/05/23 09:31:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTrapParallelSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTrapParallelSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTrapParallelSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTrapParallelSide.cc,v 
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTubsFlatSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTubsFlatSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTubsFlatSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTubsFlatSide.cc,v 1.7 2007/05/23 09:31:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTubsHypeSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTubsHypeSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTubsHypeSide.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistTubsHypeSide.cc,v 1.6 2007/05/18 07:39:56 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistTubsSide.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistTubsSide.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistTubsSide.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TwistTubsSide.cc,v 1.5 2006/06/29 18:49:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4TwistTubsSide.cc,v 1.6 2009/11/11 12:23:37 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -411,5 +411,4 @@
            G4int l;
            G4double      lastdeltaY = deltaY; 
-           G4ThreeVector last = deltaY; 
            for (l=0; l<maxcount; l++) {
              G4ThreeVector surfacenormal = GetNormal(xxonsurface); 
Index: trunk/source/geometry/solids/specific/src/G4TwistedBox.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistedBox.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistedBox.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedBox.cc,v 1.12 2006/06/29 18:49:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistedTrap.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistedTrap.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistedTrap.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTrap.cc,v 1.14 2006/06/29 18:49:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
